.\"
.TH cisco 7 "16 January 1992"
.SH NAME
cisco \- command processor on cisco terminal servers
.SH DESCRIPTION
This is a brief description of how to use the cisco terminal servers.
.PP
In general the command language for the cisco servers should be
self-explanatory.  The command "help" will list all available commands.
You may type "?" at any point in a command to find out what possibilities
are legal at that point in the command.
.PP
The terminal server may be in either of 2 modes.  Initially, you are in
command mode.  In this state, you are talking to the command scanner
on the terminal server.  The most common command to type at this point
is the name of a host.  That will cause the server to connect you to
the specified host.  If the host you want to talk to uses Unix, you
may prefer to use the rlogin command, e.g. "rlogin topaz" to
connect to topaz.  See below for the difference.
.PP
Once you have connected to a host, the terminal server is in the
connected state.  At that point, characters that you type go to the
host.  However there is an escape, which will allow you
to issue commands to the server.  By default, this character is ^^
i.e. control-^.  The most common escape command is escape-x
(typed as control-^ and then x).  This will return you to command mode,
without disturbing your connection to the system.  When there is
a connection open, a simple CR in command mode will reconnect you
to the current system.
.PP
Note that it is possible to have more than one connection open at a
time.  To do this, simply use ^^x to return to command mode, and
then type the name of a new host.  You can switch between connections
by using ^^x and then the "resume" command.  "resume" takes an
argument, which can be the number or name of the connection.  Initially,
the name is simply the name of the host you are connected to.  (This
can be changed with the "name" command.)  Use the "where" command to
look at your open connections.  DONT FORGET TO LOG OUT OF ALL MACHINES
WHEN YOU ARE FINISHED.  Otherwise whoever uses your terminal next will
end up with your jobs.  If you want to change the escape character,
the command "term escape N" can be used to change it.  You can make sure
that no one uses your terminal by locking it with the "lock" command.
.PP
By default, your terminal session will not have a local hold
character.  This character will stop output, much as ^S normally does when you
are directly connected to a host.  Type any character to resume
output.   We suggest that you use ^\\ (control-\\) so that it does not
interfere with 
characters that you need to type for Emacs and other programs.  Your system
administrator may have already configured this for you.
If this choice is bad for you, the command "term hold c" can be
used to change it to the character "c".  On Sun and VMS systems,
^S and ^Q will also work for stopping and starting output.  However
on some systems ^S will not work over the network, or there will be
too long a delay for it to be useful.  In this case the hold
character is more useful.
.PP
If you are connected to several machines, you will not be notified
if output appears on a connection other than the current one.
This can be enabled by "term notify".
.PP
Things that you change with "term" will not last past your current
session.  If you are taking over a terminal that was recently in use, you
can use "quit" to make sure that the old session is terminated,
and you are starting clean.  If you have a private terminal, it is
possible for us to set things up so that settings will be remembered
between sessions.  
.PP
By default, connections are normally made using the "telnet" protocol.
This is the official Internet standard protocol for remote terminal
service.  (In a few cases, connections to VAXes running the VMS
operation system may be made using LAT, DEC's proprietary terminal
server protocol.)
There is an alternate protocol, called "rlogin".  This
is not an Internet standard.  It was invented specifically for use
with Berkeley Unix systems.  You invoke rlogin by using the
rlogin command to connect to the host.  E.g. to connect to the
host topaz,
.nf

  telnet topaz      - uses telnet
  rlogin topaz      - uses rlogin
  lat topaz         - uses LAT
  topaz             - default protocol, which is telnet

.fi
The original Berkeley version of telnet did not do a very good
job of handling flow control (^S and ^Q) or of aborting output when
you hit ^C or ^O.  For such systems, rlogin will give better results.
However for Unix (e.g. Sun) and VMS systems using current software
telnet should work at least as well.
.PP
If you use a microcomputer through a terminal server, you'll want to
know about "term download".  Normally, the cisco terminal server
responds to several special characters, including your escape
character (usually ^^) and your hold character (usually ^\\).
Certain software, e.g. XMODEM, requires the ability to send and
receive every possible character.  In order to use this software, you
have to tell the terminal server to disable all of its special control
characters.  To do this, use the command "term download".  Note that
you must type this command to the cisco command level.  This means
that you should type it before you connect to the computer to log in,
or you should get to cisco command level using ^^x, as described
above.  Once you have typed "term download", ^^x and ^\\ will no longer
have any special effect.  You can still get back to cisco command
level by hitting the BREAK key, if your terminal has one.  Note that
you do not need to use download mode to use KERMIT, but you do need to
use it for most other file-transfer software, e.g.  XMODEM or UUCP.
Aside from turning off special characters, download mode changes the
way the terminal server handles the Telnet protocol, so as to give
you a transparent, 8-bit link to the host machine.  This works only
if the host machine implements Telnet in a matching way.  Most Unix
systems do.  To get back into normal mode, type "term no download".

.SH LOGGING INTO THE TERMINAL SERVER
.PP
The administrator of your terminal server may want you to login to the terminal
server.  If it has been configured this way, the terminal server asks you
for a user name and password.  However if you type the "who" command,
you'll see that the terminal server now knows who you are.  If you're
sharing a terminal, you can use the "login" command to change identities
without disconnecting.
.PP
Either way, the terminal server checks your name and password against
databases of allowed users.  The terminal server itself doesn't
have any user database.  (It doesn't have any disk, so there's
no place to store it.)  This database is stored on
some hosts at your site.  You need to talk to your system administrator to get
yourself put into the database, if you aren't already there.

.SH SPECIAL ESCAPE COMMANDS
.PP
One special character is defined as the "escape" character.  It is
normally ^^, i.e. control\-^.  This character is used to prefix
commands to the terminal server when you are in the middle of a
session.  The most commonly used command is escape-x (in the usual
case, this is typed as ^^ and then x).  This has already been
described above.  It suspends your session and returns you to the
terminal server command processor.
.PP
In addition, when you are using telnet, the escape commands shown
below are defined.  Most of them are fairly esoteric.  However
interrupt and abort output are often useful as alternatives to
control-C and control-O on Unix and VMS.  By typing them as telnet
escape commands the terminal server is able to abort output
immediately.  If you do control-C and control-O normally, you'll
sometimes get several screens of output before they take effect.
Break is often useful for IBM systems, since the break key on
your keyboard often does not work over the network.  The telnet
escape command version of break should always have the right effect.
.nf

  escape-b \- break - equivalent to hitting the break key
             On Unix, does a "quit", which interrupts the
             current program and causes it to coredump.
             On VMS, seems to be the same as interrupt.
  escape-c \- interrupt - stop the current program.  On Unix
             and VMS, this is equivalent to control-C, but
             stops output more quickly.
  escape-h \- backspace - this is normally equivalent to
             the backspace key, control-H
  escape-o \- abort output - On Unix and VMS, this is
             equivalent to control-O, but stops output more
             quickly.
  escape-t \- are you there? - Request the system to print a
             brief status message.  On VMS and on Unix
             systems that implement control-T, this is
             equivalent to control-T.
  escape-u \- erase line

.fi
.SH TN3270
.PP
IBM mainframe software is generally designed to work with special IBM
terminals, referred to as 3270's.  (The term 3270 is used here to
refer to several families of terminals that developed from the
original model 3270.)  If you use a standard asynchronous terminal or
PC to access an IBM mainframe, you may not be able to use certain
software, and other software may run only in a degraded "dumb terminal
mode".  The cisco terminal servers contain a 3270 emulator, which
allows normal terminals to act like 3270's.  In order to use this
emulator, you should use the "tn3270" command when connecting to an
IBM mainframe.  E.g. to connect to the computer "rutadm" using 3270
emulation, use the command "tn3270 rutadmin".
(It is possible for the system administrator to set
things up so that you get tn3270 by default when connecting to certain
systems.  In this case you can simply type the name of the system.)
Not all of the cisco terminal servers have the tn3270
command, becasue it takes up too much memory for older processors.
If your terminal server does not implement the command, you will
get one of the following two messages:
.nf

    % Unknown command or computer name,
       or unable to find computer address
    Trouble allocating tn3270 structures

.fi
.PP
In order to use tn3270, the terminal server must know what kind of
terminal you are using.  To set your terminal type, use a command like
"term term vt100".  You must type this command to the terminal server
before connecting to the IBM system.  In place of vt100, use the
actual kind of terminal you are using.  To see a list of the terminals
that the terminal server knows about, use the command "show ttycap
all".  The output will look something like this:
.nf

wyse    wy|wyse
v55     V5|v55|v55w|vi55|visual 55
v200    V2|v200|vi200|visual 200 with function keys
default d0|default|vt100|v100|vt100-am|vt100|dec-vt100

.fi
The names separated by |'s are all equivalent.  Sometimes several
different kinds of terminals are the same as far as our software is
concerned, or the same terminal type is known by several names.
.PP
If you are using a microcomputer communications package, your
documentation should say what kind of terminal it emulates.  If it
does not, we suggest trying "vt100".
.PP
Software designed for 3270's normally uses PF keys and
other special keys on the 3270 keyboard.  Because normal terminals do
not always have these keys, tn3270 uses a "keymap" to let you type
special 3270 keys by using sequences of normal keys.  To see the
keymap current in effect, use the command "show keymap".  Here's what
a keymap looks like.  (This one is the keymap you get if you don't
specify something else.)
.nf

generic{ clear = '^z'; flinp = '^x'; enter = '^m';
      delete = '^d' | '^?'; insrt = '\E ';
      synch = '^r'; reshow = '^v'; eeof = '^e'; tab = '^i';
      btab = '^b'; nl = '^n'; left = '^h'; right = '^l';
      up = '^k'; down = '^j'; einp = '^w'; reset = '^t';
      xoff = '^s'; xon = '^q'; escape = '^c'; ferase = '^u';
      pa1 = '^p1'; pa2 = '^p2'; pa3 = '^p3';
      pfk1 = '\E1'; pfk2 = '\E2'; pfk3 = '\E3'; pfk4 = '\E4';
      pfk5 = '\E5'; pfk6 = '\E6'; pfk7 = '\E7'; pfk8 = '\E8';
      pfk9 = '\E9'; pfk10 = '\E0'; pfk11 = '\E-'; pfk12 = '\E=';
      pfk13 = '\E!'; pfk14 = '\E@'; pfk15 = '\E#';
      pfk16 = '\E$'; pfk17 = '\E%'; pfk18 = '\E\^';
      pfk19 = '\E&'; pfk20 = '\E*'; pfk21 = '\E(';
      pfk22 = '\E)'; pfk23 = '\E_'; pfk24 = '\E+';
}

.fi
For example, to hit the 3270 "clear" key, type ^Z (control-Z).  Note
that there are two different ways to hit the 3270 delete key: ^D
(control-D) or ^?.  ^? means the key labelled DELETE or RUBOUT.  (On
PC keyboards, the key labelled with a left arrow may do this.)  The PF
keys (denoted pfk1 through pfk24) are generated by hitting the escape
key (denoted \E) and then another character.  (Note that "insert" is
also done this way: it is escape followed by space.)  The escape key is
normally labelled ESC or ALT.  Note that the characters used for the
PF keys have been chosen so they are arranged the same way as the real
PF keys.  There are normally 12 PF keys at the top of the keyboard.
The keys 1 - 9, 0, -, and = are normally in a similar position.  PF
keys 13 through 24 are often generated by shifting PF keys 1 through
12.  Note that the characters chosen for PF 13 through 24, ! through
+, are shifted versions of the characters chosen for PF 1 through 12.
.PP
To see all the keymaps available on the terminal server, use the
command "show keymap all".  To select a different keymap, use the
command "term keymap-type XXX", where XXX is one of the keymap types
listed in "show keymap all".  If you choose a non-existent keymap
type, the generic map shown above will be used.  You can do
"show keymap" to verify that you have selected the keymap that you
intended.

.SH SLIP
.PP
The terminal server may also be configured to support SLIP (serial-line
IP).  This allows your PC to dial up, connect to the terminal server, and
become an IP host.  You will need some special software for your PC.  Once
you've dialed up and logged into the terminal server, you can normally
start SLIP with the command "slip mypc" or "slip 131.108.1.1" where mypc is
the hostname for your system and 131.108.1.1 is the IP address.  You should
talk to your system administrator to find out your hostname, IP address,
and more about how SLIP should be used at your site.  You may not have to
type a hostname or IP address at all.

.SH XREMOTE
.PP
If you have an X terminal at home, you can also use X through the terminal
server.  Your site will normally have one or more machines running the X
display manager, a program called "xdm".  You'll have to find out which
ones from your system administrator.  You can start X from the terminal
server by giving the command "xremote xdm topaz", where topaz is the name
of your xdm server.
.PP
We stronly suggest that you use at least 9600 baud for XRemote.  We also
find that PEP (a protocol in use on Telebit modems) is inferior to the
plain V.32 protocol.  Your mileage may vary depending on your equipment and
how you use it.

.SH COMMAND REFERENCE

Here is a list of all user-level terminal server commands, as of
release 9.0:
.nf

connect <host>  Connect to host - same as just a host name
disconnect <cn> Break the connection, by name or number
exit, quit      Close all connections and free the terminal
lat <service>   Connect to service using DEC LAT protocol
lock            Lock the terminal
login           Log in as a particular user
name-connection Give a connection a logical name
resume          Make the named connection be current
rlogin <host>   Connect to host using Unix rlogin protocol
show <cmd>      Information commands, type "show ?" for list
slip <addr>     Enter SLIP mode
systat          Show terminal lines and users
telnet <host>   Connect to host using telnet protocol
tn3270 <host>   Connect to host using IBM 3270 emulation
terminal        Change terminal's parameters
where           Show open connections
xremote         Enter XRemote mode
<cr>            To resume connection

.fi 
Here are the parameters you can set using the "term" command.
Commands normally take two arguments, a keyword and value, e.g. "term
speed 9600" to set the speed to 9600.  However a few commands take
only a keyword.  They are commands that set a specific mode, e.g.
"term download" to turn on download mode.  The commands preceded by *
can be used with "no" in front of them to cancel the effect, e.g. "no
term download" to cancel download mode.
.nf

databits  5|6|7|8
   number of data bits sent, must be consistent with your 
   terminal or communications software.  Normally 7 or 8.
*download
   disables special characters, for use with XMODEM or other 
   software that requires a completely transparent path
*escape-character  <decimal-number>|<control-char>
   to get special effects during a connection, type this 
   and then another character.  See section on "special
   escape commands" above.
flowcontrol  none|hardware|software  [in|out]
   software flow control is ^S/^Q (XON/XOFF).  Hardware 
   flow control causes a hardware handshake between 
   terminal server and terminal or modem.
*hold-character  <decimal-number>|<control-char>
   typing this character will pause output
*length  <length>
   number of lines on terminal.
*width <width>
   width of lines on terminal
*notify
   send message to terminal when data arrives on a 
   connection other than the current one
*padding <decimal-number>  <count>
   send specified number of nulls after specified character
   (used primarily for older hardcopy terminals that need
   nulls to give carriage returns time to happen)
parity  none|even|odd|space|mark
   parity of characters sent, must be consistent with your 
   terminal or communications software.
*transport preferred telnet|pad|lat|rlogin|none
   when you use the connect command, try this method of 
   connection first
speed  300|600|1200|2400|4800|9600|19200|38400
   line speed.  Must match the speed of your terminal or 
   mode
*start-character  <decimal-number>|<control-char>
   character used for software flow control
*stop-character  <decimal-number>|<control-char>
   character used for software flow control
stopbits  1|1.5|2
   number of stop bits after character.  Must match your 
   terminal or communications software.  Typically 1 for
   modern terminals.
telnet-transparent
   change carriage return handling.  Try this if you are 
   seeing extra blank lines.
terminal-type  <string>
   tell the system the type of terminal you are on

.fi
Here are the things you can look at with the "show" command:
.nf

entry            Incoming queue entries
hosts            Host/address cache
lat <keyword>    LAT Protocol information, type ? for list
sessions         Telnet and rlogin connections
terminal         Terminal parameters
users            Summary of active lines and connections
version          Hardware configuration and software version
xremote <keyword> XRemote information, type ? for list

.fi
.SH AUTHOR
.PP
This man page was started by Chuck Hedrick and is currently provided as
unsupported documentation by cisco.  It's available from the
anonymous ftp server ftp.cisco.com.  Get the file README for more
information.

